#include "rational.hpp"
#include <iostream>

int main() {

	Rational a(2, 3);
	Rational b(1, 2);
	Rational x(5, 1);
	Rational y(17);

	try{
		
	
		Rational c = (a * b) * x;
		a *= Rational(2);
	
		std::cout << a << std::endl;	
		std::cout << b.toString() << std::endl;
		std::cout << c.toString() << std::endl;
	
	
		std::cout << b + Rational(1,4) << std::endl;
		b += Rational(2,4);
		std::cout << b << std::endl;
	
		std::cout << b - Rational(1,4) << std::endl;
		b -= Rational(2,4);
		std::cout << b << std::endl;

		std::cout << b / Rational(1,0) << std::endl;
	}catch (const std::exception& e) {
		std::cout << "Exception: " << e.what() << std::endl;
	}
	try{
		b /= Rational(0,4);
		std::cout << b << std::endl;
	
		a *= Rational(1,5);
		std::cout << a << std::endl;

		std::cout << (b == Rational(1)) << std::endl;
		std::cout << (b != Rational(1,4)) << std::endl;
		std::cout << (b < Rational(1,4)) << std::endl;
		std::cout << (b <= Rational(1,4)) << std::endl;
		std::cout << (b > Rational(1,4)) << std::endl;
		std::cout << (b >= Rational(1)) << std::endl;

		a *= Rational(1,4);
		std::cout << a << std::endl;
	
	}catch (const std::exception& e) {
		std::cout << "Exception: " << e.what() << std::endl;
	}

		return 0;
}
